from sys import stdin, argv
from math import log
from collections import defaultdict
from string import ascii_lowercase
from random import shuffle, randint

freq = defaultdict(float)

total = 0
for row in open(argv[1],'r').readlines():
    freq[ row[:4] ] = float( row[5:] )
    total += float( row[5:] )

for t in freq: freq[t] /= total

raw_text = stdin.read().lower()
text = ''
for x in raw_text:
    if x.isalpha(): text += x



def prekvapenie(text):
    surprise = 0.
    for i in range( len(text)-3 ): surprise -= log( freq[ text[i:i+4] ] + 1e-7 )
    return surprise

def desifruj(kluc):
    result = ''
    i = 0
    for x in text:
        n = ord(x)-97
        n += kluc[i]
        n %= 26
        result += chr(97+n)
        i = (i+1) % len(kluc)
    return result

def nahodny_kluc():
    dlzka = randint(6,15)
    kluc = [ randint(0,25) for n in range(dlzka) ]
    return kluc

def vylepsi_kluc(kluc):
    teraz = prekvapenie( desifruj(kluc) )
    best, bx, by = teraz, None, None
    for i in range(len(kluc)):
        for j in range(26):
            tmp = kluc[i]
            kluc[i] = j
            toto = prekvapenie( desifruj(kluc) )
            if toto < best: best, bx, by = toto, i, j
            kluc[i] = tmp
    
    if bx is not None:
        kluc[bx] = by
        return True
    return False

gbest = 1e30
while True:
    kluc = nahodny_kluc()
    while vylepsi_kluc(kluc):
        teraz = prekvapenie( desifruj(kluc) )
        if teraz < gbest:
            gbest = teraz
            print('{:.4f} keylen={} {}'.format(gbest,len(kluc),desifruj(kluc)[:80]))


